/*
    via686a.c - It has been based on chips.c to be used on HotApplet 
    by Daniel Baeyens <daniel.baeyens@hispalinux.es>
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "chips.h"
#include "it87.h"
#include <sensors/sensors.h>
#include <sensors/chips.h>

#include <gnome.h>

int get_IT87_features(sensors_chip_name name, gchar *feature, gchar *c_return){
   int error = 0;	
   double value;

   gchar *label=NULL;
   int valid;
   
   if (!strcmp("TEMP1", feature)) 
	       {
		      if ((!sensors_get_label_and_valid(name, SENSORS_IT87_TEMP1, &label, &valid)) &&
			   (!sensors_get_feature(name, SENSORS_IT87_TEMP1,&value)))
			{
		            g_snprintf(c_return, 7, "%3.1f", value);
		            error = 0;
			}
			else
			{
			    g_snprintf(c_return, 7, "--");
		            error = 1;
			}
	       }
    else if (!strcmp("TEMP2", feature)) 
	       {
		      if ((!sensors_get_label_and_valid(name, SENSORS_IT87_TEMP2, &label, &valid)) &&
			   (!sensors_get_feature(name, SENSORS_IT87_TEMP2,&value)))
			{
		            g_snprintf(c_return, 7, "%3.1f", value);
		            error = 0;
			}
			else
			{
			    g_snprintf(c_return, 7, "--");
			    error = 1;
			}
		     
	       }
    else if (!strcmp("TEMP3", feature)) 
	       {
		      if ((!sensors_get_label_and_valid(name, SENSORS_IT87_TEMP3, &label, &valid)) &&
			   (!sensors_get_feature(name, SENSORS_IT87_TEMP3,&value)))
			{
		            g_snprintf(c_return, 7, "%3.1f", value);
		            error = 0;
			}
			else
			{
			    g_snprintf(c_return, 7, "--");
			    error = 1;
			}
		     
	       }
   else if (!strcmp("LOW1", feature))
	       {
		      if ((!sensors_get_label_and_valid(name, SENSORS_IT87_TEMP1_LOW, &label, &valid)) &&
		          (!sensors_get_feature(name, SENSORS_IT87_TEMP1_LOW,&value)))
		       {
		           g_snprintf(c_return, 7, "%3.1f", value);
		           error = 0;
		       }
		       else
		       {
		           g_snprintf(c_return, 7, "--");
		           error = 1;
		       }
		      
	       }
   else if (!strcmp("LOW2", feature))
	       {
		      if ((!sensors_get_label_and_valid(name, SENSORS_IT87_TEMP2_LOW, &label, &valid)) &&
		          (!sensors_get_feature(name, SENSORS_IT87_TEMP2_LOW,&value)))
		       {
		           g_snprintf(c_return, 7, "%3.1f", value);
		           error = 0;
		       }
		       else
		       {
		           g_snprintf(c_return, 7, "--");
		           error = 1;
		       }
	       }
   else if (!strcmp("LOW3", feature))
	       {
		      if ((!sensors_get_label_and_valid(name, SENSORS_IT87_TEMP3_LOW, &label, &valid)) &&
		          (!sensors_get_feature(name, SENSORS_IT87_TEMP3_LOW,&value)))
		       {
		           g_snprintf(c_return, 7, "%3.1f", value);
		           error = 0;
		       }
		       else
		       {
		           g_snprintf(c_return, 7, "--");
		           error = 1;
		       }
	       }
   else if(!strcmp("HIGH1", feature))
	       {
		      if ((!sensors_get_label_and_valid(name, SENSORS_IT87_TEMP1_HIGH, &label, &valid)) &&
		          (!sensors_get_feature(name, SENSORS_IT87_TEMP1_HIGH,&value)))
		       {
		           g_snprintf(c_return, 7, "%3.1f", value);
		           error = 0;
		       }
		       else
		       {
		           g_snprintf(c_return, 7, "--");
		           error = 1;
		       }
	       }
   else if(!strcmp("HIGH2", feature))
	       {
		      if ((!sensors_get_label_and_valid(name, SENSORS_IT87_TEMP2_HIGH, &label, &valid)) &&
		          (!sensors_get_feature(name, SENSORS_IT87_TEMP2_HIGH,&value)))
		       {
		           g_snprintf(c_return, 7, "%3.1f", value);
		           error = 0;
		       }
		       else
		       {
		           g_snprintf(c_return, 7, "--");
		           error = 1;
		       }
	       }
   else if(!strcmp("HIGH3", feature))
	       {
		      if ((!sensors_get_label_and_valid(name, SENSORS_IT87_TEMP3_HIGH, &label, &valid)) &&
		          (!sensors_get_feature(name, SENSORS_IT87_TEMP3_HIGH,&value)))
		       {
		           g_snprintf(c_return, 7, "%3.1f", value);
		           error = 0;
		       }
		       else
		       {
		           g_snprintf(c_return, 7, "--");
		           error = 1;
		       }
	       }
   else             
   	       {
		  g_snprintf(c_return, 7, "--");     
	          error = 1;
	       }
   //   g_free(label);

   return error;
} 
