/*
    via686a.c - It has been based on chips.c to be used on HotApplet 
    by Daniel Baeyens <daniel.baeyens@hispalinux.es>
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "chips.h"
#include "w83781d.h"
#include <sensors/sensors.h>
#include <sensors/chips.h>

#include <gnome.h>

int get_W83781D_features(sensors_chip_name name, gchar *feature, gchar *c_return){
//   gchar *cadena;
   int error = 0;	
   double value;

   gchar *label=NULL;
   int valid;
   
//   cadena = g_malloc0(7*sizeof(gchar));
   if (!strcmp("TEMP1", feature)) 
	       {
		      if ((!sensors_get_label_and_valid(name, SENSORS_W83781D_TEMP1, &label, &valid)) &&
			   (!sensors_get_feature(name, SENSORS_W83781D_TEMP1,&value)))
			{
		            g_snprintf(c_return, 7, "%3.1f", value);
		            error = 0;
			}
			else
			{
			    g_snprintf(c_return, 7, "--");
		            error = 1;
			}
	       }
    else if (!strcmp("TEMP2", feature)) 
	       {
		      if ((!sensors_get_label_and_valid(name, SENSORS_W83781D_TEMP2, &label, &valid)) &&
			   (!sensors_get_feature(name, SENSORS_W83781D_TEMP2,&value)))
			{
		            g_snprintf(c_return, 7, "%3.1f", value);
		            error = 0;
			}
			else
			{
			    g_snprintf(c_return, 7, "--");
			    error = 1;
			}
		     
	       }
    else if (!strcmp("TEMP3", feature)) 
	       {
		      if ((!sensors_get_label_and_valid(name, SENSORS_W83781D_TEMP3, &label, &valid)) &&
			   (!sensors_get_feature(name, SENSORS_W83781D_TEMP3,&value)))
			{
		            g_snprintf(c_return, 7, "%3.1f", value);
		            error = 0;
			}
			else
			{
			    g_snprintf(c_return, 7, "--");
			    error = 1;
			}
		     
	       }
   else if (!strcmp("HYST1", feature))
	       {
		      if ((!sensors_get_label_and_valid(name, SENSORS_W83781D_TEMP1_HYST, &label, &valid)) &&
		          (!sensors_get_feature(name, SENSORS_W83781D_TEMP1_HYST,&value)))
		       {
		           g_snprintf(c_return, 7, "%3.1f", value);
		           error = 0;
		       }
		       else
		       {
		           g_snprintf(c_return, 7, "--");
		           error = 1;
		       }
		      
	       }
   else if (!strcmp("HYST2", feature))
	       {
		      if ((!sensors_get_label_and_valid(name, SENSORS_W83781D_TEMP2_HYST, &label, &valid)) &&
		          (!sensors_get_feature(name, SENSORS_W83781D_TEMP2_HYST,&value)))
		       {
		           g_snprintf(c_return, 7, "%3.1f", value);
		           error = 0;
		       }
		       else
		       {
		           g_snprintf(c_return, 7, "--");
		           error = 1;
		       }
	       }
   else if (!strcmp("HYST3", feature))
	       {
		      if ((!sensors_get_label_and_valid(name, SENSORS_W83781D_TEMP3_HYST, &label, &valid)) &&
		          (!sensors_get_feature(name, SENSORS_W83781D_TEMP3_HYST,&value)))
		       {
		           g_snprintf(c_return, 7, "%3.1f", value);
		           error = 0;
		       }
		       else
		       {
		           g_snprintf(c_return, 7, "--");
		           error = 1;
		       }
	       }
   else if(!strcmp("OVER1", feature))
	       {
		      if ((!sensors_get_label_and_valid(name, SENSORS_W83781D_TEMP1_OVER, &label, &valid)) &&
		          (!sensors_get_feature(name, SENSORS_W83781D_TEMP1_OVER,&value)))
		       {
		           g_snprintf(c_return, 7, "%3.1f", value);
		           error = 0;
		       }
		       else
		       {
		           g_snprintf(c_return, 7, "--");
		           error = 1;
		       }
	       }
   else if(!strcmp("OVER2", feature))
	       {
		      if ((!sensors_get_label_and_valid(name, SENSORS_W83781D_TEMP2_OVER, &label, &valid)) &&
		          (!sensors_get_feature(name, SENSORS_W83781D_TEMP2_OVER,&value)))
		       {
		           g_snprintf(c_return, 7, "%3.1f", value);
		           error = 0;
		       }
		       else
		       {
		           g_snprintf(c_return, 7, "--");
		           error = 1;
		       }
	       }
   else if(!strcmp("OVER3", feature))
	       {
		      if ((!sensors_get_label_and_valid(name, SENSORS_W83781D_TEMP3_OVER, &label, &valid)) &&
		          (!sensors_get_feature(name, SENSORS_W83781D_TEMP3_OVER,&value)))
		       {
		           g_snprintf(c_return, 7, "%3.1f", value);
		           error = 0;
		       }
		       else
		       {
		           g_snprintf(c_return, 7, "--");
		           error = 1;
		       }
	       }
   else             
   	       {
		  g_snprintf(c_return, 7, "--");     
	          error = 1;
	       }
   //   g_free(label);

   return error;
} 
